/*
 * Copyright 2013 gregorygraham.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nz.co.gregs.dbvolution.operators;

import nz.co.gregs.dbvolution.databases.DBDatabase;
/**
 *
 * @author gregorygraham
 */
public class DBIsNullOperator extends DBOperator {

    @Override
    public String generateWhereLine(DBDatabase database, String columnName) {
        return database.beginAndLine() + columnName + (invertOperator ? getInverse() : getOperator());
    }

    private String getOperator() {
        return " is null ";
    }
    
    private String getInverse() {
        return " is not null ";
    }

    @Override
    public String generateRelationship(DBDatabase database, String columnName, String otherColumnName) {
        throw new UnsupportedOperationException("The DB IS NULL Operator Cannot Be Used To Specify a Relationship"); //To change body of generated methods, choose Tools | Templates.
    }
    
}
